// FiboDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Fibo.h"
#include "FiboDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CFiboDlg dialog



CFiboDlg::CFiboDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFiboDlg::IDD, pParent)
	, dMax(0)
	, dMin(0)
	, dAct(0)
	, dUpXOP(0)
	, dUpOP(0)
	, dUpCOP(0)
	, dDownCOP(0)
	, dDownOP(0)
	, dDownXOP(0)
	, dRatioMax(0)
	, dRatioMin(0)
	, d038FromMin(0)
	, d038FromMax(0)
	, m_bWinOnTop(TRUE)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CFiboDlg::DoDataExchange(CDataExchange* pDX)
{
	DDX_Text(pDX,IDC_EDIT1,dMax);
	DDX_Text(pDX,IDC_EDIT2,dMin);
	DDX_Text(pDX,IDC_EDIT3,dAct);
	DDX_Text(pDX,IDC_EDIT4,dUpXOP);
	DDX_Text(pDX,IDC_EDIT5,dUpOP);
	DDX_Text(pDX,IDC_EDIT6,dUpCOP);
	DDX_Text(pDX,IDC_EDIT7,dDownCOP);
	DDX_Text(pDX,IDC_EDIT8,dDownOP);
	DDX_Text(pDX,IDC_EDIT9,dDownXOP);
	DDX_Text(pDX,IDC_EDIT10,dRatioMax);
	DDX_Text(pDX,IDC_EDIT11,dRatioMin);
	DDX_Text(pDX,IDC_EDIT12,d038FromMax);
	DDX_Text(pDX,IDC_EDIT13,d038FromMin);



	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CFiboDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_WM_SYSCOMMAND()
	ON_WM_CTLCOLOR()
END_MESSAGE_MAP()


// CFiboDlg message handlers

BOOL CFiboDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// Modify system menu (top left menu)
	CMenu* pSysMenu = GetSystemMenu(FALSE);
	pSysMenu->AppendMenu(MF_SEPARATOR);
	if (pSysMenu != NULL)
	{
		//pSysMenu->AppendMenu(MF_SEPARATOR);
		CString strStayOnTop;
		strStayOnTop.LoadString(IDS_STAYONTOP);
		if (!strStayOnTop.IsEmpty()) pSysMenu->AppendMenu(MF_STRING, IDS_STAYONTOP, strStayOnTop);
	}

	WinOnTop();
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CFiboDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CFiboDlg::OnQueryDragIcon()
{
	//return static_cast<HCURSOR>(m_hIcon);
	return (HCURSOR) m_hIcon;
}

void CFiboDlg::OnBnClickedOk()
{
	UpdateData(TRUE);

	d038FromMax = dMax - 0.38 *(dMax - dMin);
	d038FromMin = dMin + 0.38 *(dMax - dMin);

	if (dAct != 0 && dAct<= dMax && dAct>=dMin)
	{
		dUpXOP = 1.618 * (dMax - dMin) + dAct;
		dUpOP  = dMax - dMin + dAct;
		dUpCOP = 0.618 * (dMax - dMin) + dAct;

		dDownCOP = 0.618 * (dMin - dMax) + dAct;
		dDownOP  = dMin - dMax + dAct;
		dDownXOP = 1.618 * (dMin - dMax) + dAct;

		if (dMax == dMin)	
		{
			dRatioMax = 0.0;
			dRatioMin = 0.0;
		}
		else
		{
			dRatioMax = (dMax-dAct)/(dMax-dMin);
			dRatioMin = 1 - dRatioMax;
		}
	}
	else
	{
		dUpXOP = 0;
		dUpOP  = 0;
		dUpCOP = 0;

		dDownCOP = 0;
		dDownOP  = 0;
		dDownXOP = 0;

		dRatioMax = 0.0;
		dRatioMin = 0.0;
	}

	UpdateData(FALSE);

	//OnOK();
}

void CFiboDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if (nID == IDS_STAYONTOP)
	{
		WinOnTop();
		return;
	}
	CDialog::OnSysCommand(nID, lParam);
}

void CFiboDlg::WinOnTop(void)	// XPS_IB Window on top
{
	CString m_RegXPSKey = "Software\\XPS\\DefaultSettings";
	CMenu* pSysMenu = GetSystemMenu(FALSE); // copy system menu for modifs.
	CWinApp *pApp= AfxGetApp();
	if (!m_bWinOnTop)
	{
		pSysMenu->CheckMenuItem(IDS_STAYONTOP,MF_CHECKED);
		pApp->m_pMainWnd->SetWindowPos(&CWnd::wndTopMost, 0, 0, 0, 0,SWP_NOMOVE|SWP_NOSIZE);
	}
	else
	{
		pSysMenu->CheckMenuItem(IDS_STAYONTOP,MF_UNCHECKED);
		pApp->m_pMainWnd->SetWindowPos(&CWnd::wndNoTopMost, 0, 0, 0, 0,SWP_NOMOVE|SWP_NOSIZE);
	}
	m_bWinOnTop = !m_bWinOnTop;	// toggle
}


HBRUSH CFiboDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor)
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);

	// TODO:  Change any attributes of the DC here

	// TODO:  Return a different brush if the default is not desired
	return hbr;
}
